#!/usr/bin/env python3

def my_exp(x):
    """Calculates an approximate value of the exponential function exp(x) of 
    ``x``.

    Uses the Taylor-Series for the approximation and stops if the value of 
    the series does not change anymore.

    Args:
        x (float):
            An arbitrary floating point number.

    Returns:
        float:
            The value of exp(x) calculated by the use of the Taylor-Series.
    """
    # TODO
    e = 10 ** (-100)
    k = 1
    fact = 1
    exp = 1.0

    #term = 1.0
    #result = 1.0

    while True:

    #    term *= x / (k)
    #    result += term
    #    if abs(term/result) < 1e-100:  # Abbruchbedingung für Konvergenz
    #        print ("ok")
    #        break

        alt_exp = exp
        exp = exp + (x ** k) / fact
        if abs(alt_exp - exp) < e:
            break
        k = k + 1
        fact = fact * k
    #print("result ist ", result)
    return exp


def diff1(f, x, h=1e-8):
    """Calculates an approximate value of the first derivative by using the
    *forward* differences formula.

    Args:
        f ():
            The function that should be differenciated.
        x (float):
            Point at which the derivative should be calculated.
        h (float, *optional*=``1e-8``):
            Stepsize, should be small, but not too small.

    Returns:
        float:
            Approximate Value of the derivate of ``f`` at ``x``.
    """
    return (f(x + h) - f(x)) / h # TODO


def diff2(f, x, h=1e-8):
    """Calculates an approximate value of the first derivative by using the
    *central* differences formula.

    Args:
        f ():
            The function that should be differenciated.
        x (float):
            Point at which the derivative should be calculated.
        h (float, *optional*=``1e-8``):
            Stepsize, should be small, but not too small.

    Returns:
        float:
            Approximate Value of the derivate of ``f`` at ``x``.
    """
    return (f(x + h) - f(x - h)) / (2 * h) # TODO


def sqrt(x):
    """Calculates the approximate value of the square root of ``x``.

    Args:
        x (float):
            The value to be taken the square root of.

    Returns:
        float:
            Approximate Value of the square root of ``x``.
    """
    assert x >= 0
    e = 10e-15
    # TODO
    x_n = x
    while True:
        x_plus = 0.5 * (x_n + x / x_n)
        x_n = x_plus
        if abs((x_n ** 2) - x) <= (x * e):
            break
    return x_plus


def main():
    """The Main-Function of the programme. Is executed whenever this file is
    executed at top level.

    Hier kann beliebiger Testcode stehen, der bei der Korrektur vollständig
    ignoriert wird.
    """
    print("exp(0)", my_exp(0))
    print("exp(2)", my_exp(2))
    print("exp(9)", my_exp(9))
    print("exp(25)", my_exp(25))
    print("exp(-2)", my_exp(-2))
    print("exp(-24)", my_exp(-24))
    print("exp(-25)", my_exp(-25))

    f = lambda x: x**2
    print("\nf(x) = x^2")
    d1 = diff1(f, 4, 0.1)
    d2 = diff2(f, 4, 0.1)
    fehler = abs(d1 - d2)
    print("diff1 ist ", d1, "diff2 ist ", d2, "Fehler ist ", fehler, "with h = 0.1")
    d1 = diff1(f, 4)
    d2 = diff2(f, 4)
    fehler = abs(d1 - d2)
    print("diff1 ist ", d1, "diff2 ist ", d2, "Fehler ist ", fehler, "with h = 1e-8")

    print("\nsqrt(4) ist", sqrt(4))
    print("\nsqrt(2) ist", sqrt(2))

if __name__ == "__main__": main()