#!/usr/bin/env python3

def is_prime(n):
    """Checks if the given number is prime.

    Args:
        n (int):
            Integer that should be checked.

    Returns:
        bool:
            True iff n is a prime number, False otherwise.
    """
    if n == 0 or n == 1: return False
    # TODO
    nb = n
    if nb < 2:
        return False
    else:
        for i in range(1, nb + 1):
            if nb % i == 0 and i != 1 and i != nb:
                return False
    return True


def int2str(n, base):
    """Conversts an integer ``n`` into a string representation with respect
    to the basis ``base``.

    Args:
        n (int):
            Integer to be converted.
        base (int):
            With respect to which base the number should be represented.

    Returns:
        str:
            String representation of the number.
    """
    digits = "0123456789abcdefghijklmnopqrstuvwxyz"
    assert 2 <= base <= 36, "Invalid base"
    # TODO
    nb = n
    basis = base
    if nb == 0:
        return "0"
    else:
        result = []
        while nb > 0:
            rest = nb % basis
            if rest < 10:
                result.append(str(rest))
            else:
                result.append(chr(rest - 10 + ord('a')))
            nb = nb // basis
    return ''.join(result[::-1])


def is_emirp(n):
    """Checks if the interger ``n`` is an emirp-number, i.e. a prime that
    results in a different prime whenever you mirror its decimal representation.

    Args:
        n (int):
            Number to be checked.

    Returns:
        bool:
            True iff nis an emirp-number, False otherwise.
    """
    if not is_prime(n): return False
    # TODO
    nb = n
    if nb < 10:
        return False
    else:
        nb_str = int2str(nb, 10)
        list_nb_spiegelbild = list(nb_str)[::-1]
        nb_str_spiegelbild = ''.join(list_nb_spiegelbild)
        nb_spiegelbild = int(nb_str_spiegelbild)
        return is_prime(nb) and is_prime(nb_spiegelbild)


def main():
    """The Main-Function of the programme. Is executed whenever this file is
    executed at top level.

    Hier kann beliebiger Testcode stehen, der bei der Korrektur vollständig
    ignoriert wird.
    """
    # Beispiel:
    for n in [1, 2, 3, 4, 5, 6, 7, 97, 98, 99]:
        print("Ist " + str(n) + " eine Primzahl? " + str(is_prime(n)))


    # Beispiel:
    print("Mirpzahlen: ", end='')
    for n in range(99):
        if is_emirp(n):
            print(' ' + str(n), end='')
    
    """for i in range(101):
        if is_prime(i):
            print(i)"""
    print(int2str(11, 2))
    print(int2str(10, 16))
    print(int2str(20, 16))
    print(int2str(32, 16))
    print(is_emirp(32))
    print(is_emirp(325))
    print(is_emirp(2))
    print(is_emirp(44733))


if __name__ == "__main__": main()