#!/usr/bin/env python3

def first_and_last_element(l):
    """Checks if the first and last element of ``l`` are identical.

    Args:
        l (List):
            The given list to check.

    Returns:
        bool:
            True iff the first and last element of ``l`` are identical, False
            otherwise.
    """
    assert len(l) >= 1
    # TODO
    if len(l) == 1:
        return True
    else:
        return l[0] == l[len(l) - 1]


def get_all_even_elements(l, start):
    """Returns all elements of ``l`` starting at ``start`` with an even index.

    Args:
        l (List):
            The list.
        start (int):
            Starting index, may be odd.

    Returns:
        List:
            List of all elements starting at ``start`` with an even index.
    """
    assert len(l) > start
    # TODO
    result = []
    for i in range(start, len(l)):
        if i % 2 == 0:
            result.append(l[i])
    return result


def get_last_two_elements(l):
    """Returns the last two elements of ``l`` in reverse order!

    Args:
        l (List):
            The list the last two elements are to be returned of. You may
            safely assume, that ``len(l) >= 2``.

    Returns:
        List:
            The last two elements of ``l``.

    Example:
        ``get_last_two_elements([1,2,3,4])`` should return ``[4, 3]``

    """
    assert len(l) >= 2
    # TODO
    return l[-1:-3:-1]


def square_elements(number_list):
    """Squares all elements of the given list.

    Args:
        number_list (List[Numeric]):
            A list of numbers that is to be squared.

    Returns:
        List[Numeric]:
            List of the squared elements of ``number_list``.
    """
    # TODO
    if number_list == []:
        return []
    for i in range(len(number_list)):
        number_list[i] **= 2
    return number_list


def filter_elements(list_one, list_two):
    """Filters all elements of ``list_one`` that are also in ``list_two``.

    Args:
        list_one (List):
            The first list.
        list_two (List):
            The second list.

    Returns:
        List:
            The filtered list.
    """
    # TODO
    result = []
    for l in list_one:
        if l in list_two:
            result.append(l)
    return result


def select_elements(l, indices):
    """Selects all elements of ``l`` whose indices are in ``indices``.

    Args:
        l (List):
            The list the items should be selected from.
        indices (List[int]):
            The list of indices.

    Returns:
        List:
            The selected elements with indices in ``indices``.
    """
    # TODO
    result = []
    str_len = len(l)
    for index in indices:
        if int(index) < str_len:
            result.append(l[index])
    return result


def main():
    """The Main-Function of the programme. Is executed whenever this file is
    executed at top level.

    Hier kann beliebiger Testcode stehen, der bei der Korrektur vollständig
    ignoriert wird.
    """
    print("\nfirst element of [1, 2, 3] egal last: ", first_and_last_element([1, 2, 3]))
    print("first element of [1, 2, 3, 1] egal last: ", first_and_last_element([1, 2, 3, 1]))
    print("first element of [80] egal last: ", first_and_last_element([80]))

    print("\nget_all_even_elements vor [0, 1, 2, 3, .., 10] start 3: ", get_all_even_elements(list(range(11)), 3))

    print("\nget_last_two_elements of [1,2,3]: ", get_last_two_elements([1, 2, 3]))
    print("get_last_two_elements of [2,3]: ", get_last_two_elements([2, 3]))

    print("\nsquare_elements of [1, 2, 3]: ", square_elements([1, 2, 3]))
    print("square_elements of []: ", square_elements([]))

    print("\nintersection [1, 2, 3, 4, 5] and [1, 4]: ", filter_elements([1, 2, 3, 4, 5], [1, 4]))

    print("\nselect elements with indices [2, 3, 5, 6, 7, 9, 0] in list [0, 1, ... , 5]", select_elements(list(range(6)), [2, 3, 5, 6, 7, 9, 0]))

if __name__ == "__main__": main()